#!/bin/bash

#(some rights reserved) 2007 mcsmart
#license: http://creativecommons.org/licenses/by-nc-sa/3.0/
#the author is not responsible for any damages caused by this script 



#simple check if the user is logged in as root
USER=`whoami`
if [[ $USER != "root" ]]; then
	echo "You need to have root-proviledges!"
	echo "To run this script, simply type 'sudo $0' and enter your password"
	exit
fi


#name of the kext
TYPE="AppleAirPortBrcm4311.kext"

#default locations
DEFAULTKEXT="/System/Library/Extensions/IO80211Family.kext/Contents/PlugIns/AppleAirPortBrcm4311.kext"
DEFAULTBCKP="/backup"

#select the kextfile
function kextsel() {
	KEXT=""
        echo "Where is the $TYPE located?"
	echo "Please enter the full path or simply press return if the default path is correct for your system!"
        read -p "[$DEFAULTKEXT] " KEXT
        if [[ $KEXT == "" ]]; then
                KEXT=$DEFAULTKEXT;
        fi
}

#select a location for the backup of the Info.plist file
function backupsel() {
	BACKUP=""
        echo "Please enter a place for the backup of the kext's Info.plist!"
        echo "If you don't want a backup, type '/dev/null' :)"
        read -p "[$DEFAULTBCKP] " BACKUP
        if [[ $BACKUP == "" ]]; then
                BACKUP=$DEFAULTBCKP;
		#create the dir if it does not exist
		if !([ -e $BACKUP ]); then
			mkdir $BACKUP
		fi
        fi
}



clear
echo "####################################"
echo "#mcsmart's bcm43xx wireless enabler#"
echo "#             v. 0.4               #"
echo "####################################"
echo "This script will enable your Broadcom wireless card (aka AirPortOne)!"
echo "You may run this script after every AirPort Update released by Apple to re-enable your card."
echo "For more information visit: http://forum.insanelymac.com/index.php?showtopic=51725"
echo ""
echo "Use this script at your own risk!"
echo "The author is not responsible for any damages that may be caused by this script!"
echo ""
echo "Supported chipsets:"
echo "- Broadcom BCM4306 802.11 b/g Wireless LAN"
echo "- Broadcom BCM4309 802.11 b Wireless LAN"
echo "- Broadcom BCM4318 [AirForce One 54g] 802.11g Wireless LAN"
echo "- Broadcom BCM4320 b/g"
echo "- Broadcom BCM4324 802.11 a/b/g Wireless LAN"
echo "- All Apple AirPortOne cards"
echo ""
echo ""
echo "Press Enter to continue"
read none

#select the kext
clear
kextsel

#try again if the kext file is invalid
while !([ -e $KEXT/Contents/Info.plist ]); do
	echo ""
	echo "Invalid path, try it again!"
	kextsel
done

#final location of the Info.plist
FILE="$KEXT/Contents/Info.plist"

#select a path to backup the Info.plist
clear
backupsel

#try again if the kext file is invalid
while !([ -e $BACKUP ]); do
        echo ""
        echo "Invalid path, try it again!"
        backupsel
done

echo $BACKUP

cat $FILE > /tmp/patch
cp $FILE $BACKUP/Info.plist.$TYPE
cat /tmp/patch|grep -B 100 "<array>" > /tmp/new
echo "				<string>pci14e4,4306</string>
				<string>pci14e4,4309</string>
				<string>pci14e4,4328</string>
                                <string>pci14e4,4329</string>
                                <string>pci14e4,432a</string>
                                <string>pci14e4,4311</string>
                                <string>pci14e4,4312</string>
                                <string>pci14e4,4313</string>
                                <string>pci14e4,4318</string>
                                <string>pci14e4,4319</string>
                                <string>pci14e4,431a</string>
				<string>pci14e4,4320</string>
				<string>pci14e4,4324</string>
                                <string>pci14e4,4315</string>" >> /tmp/new 
cat /tmp/patch|grep -A 100 "</array>" >> /tmp/new
cp /tmp/new $FILE
chown root:wheel $FILE
chmod 0644 $FILE
rm /tmp/patch
rm /tmp/new

#delete AirPort2 kext
if [ -e /System/Library/Extensions/AppleAirPort2.kext ]; then
	clear
	echo "Do you want to delete the AppleAirPort2.kext (recommended)? [yes|no]"
	echo "The kext will be moved to your backup location"
	read -p "[yes] " AP2
	if [[ $AP2 == "yes" ]]; then
		mv /System/Library/Extensions/AppleAirPort2.kext $BACKUP
	elif [[ $AP2 == "" ]]; then
		mv /System/Library/Extensions/AppleAirPort2.kext $BACKUP
	fi
fi

#delete the kextcache
rm -rf /System/Library/Extensions.kextcache
rm -rf /System/Library/Extensions.mkext

echo "$TYPE successfully patched!"
